// BSTRTest.h : Declaration of the CBSTRTest

#ifndef __BSTRTEST_H_
#define __BSTRTEST_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CBSTRTest
class ATL_NO_VTABLE CBSTRTest : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CBSTRTest, &CLSID_BSTRTest>,
	public IDispatchImpl<IBSTRTest, &IID_IBSTRTest, &LIBID_TESTBSTRRULESLib>
{
public:
	CBSTRTest()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_BSTRTEST)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CBSTRTest)
	COM_INTERFACE_ENTRY(IBSTRTest)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IBSTRTest
public:
	STDMETHOD(SomeMethodRule3)(/*[out]*/ BSTR* bstrParam);
	STDMETHOD(SomeMethodRule2)(/*[in,out]*/ BSTR* bstrParam);
	STDMETHOD(SomeMethodRule1)(/*[in]*/ BSTR bstrParam);
};

#endif //__BSTRTEST_H_
